<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_MailSmtp.php,v 1.7 2006/12/23 11:13:09 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * ソケット接続クラス
 */
require_once dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'SyL_Socket.php';

/**
 * メールサーバーのホスト名
 */
define('SYL_MAIL_SERVER_HOST', '');
/**
 * メールサーバーのポート番号
 */
define('SYL_MAIL_SERVER_PORT', 25);

/**
 * SMTPメール送信クラス
 *
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_MailSmtp.php,v 1.7 2006/12/23 11:13:09 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_MailSmtp extends SyL_Mail
{
    /**
     * メールサーバーのホスト名
     *
     * @access private
     * @var string
     */
    var $host = SYL_MAIL_SERVER_HOST;
    /**
     * メールサーバーのポート
     *
     * @access private
     * @var int
     */
    var $port = SYL_MAIL_SERVER_PORT;
    /**
     * ソケットクラス
     *
     * @access private
     * @var object
     */
    var $socket = null;

    /**
     * コンストラクタ
     *
     * @access private
     */
    function SyL_MailSmtp()
    {
        parent::SyL_Mail();
    }

    /**
     * ホストをセット
     * 
     * @access public
     * @param string ホスト名
     */
    function setHost($host)
    {
        $this->host = $host;
    }

    /**
     * ポート番号をセット
     * 
     * @access public
     * @param int ポート番号
     */
    function setPort($port)
    {
        $this->port = $port;
    }

    /**
     * メール送信前処理
     *
     * @access public
     * @param array メール送信属性
     * @param bool 完全初期化フラグ
     * @return OK: true, NG: false
     */
    function init($attributes=array(), $all=false)
    {
        $attributes = array_change_key_case($attributes, CASE_LOWER);
        parent::init($attributes, $all);

        if ($all) {
            // ホストセット
            if (isset($attributes['host'])) {
                $this->host = $attributes['host'];
            }
            // ポートセット
            if (isset($attributes['port'])) {
                $this->port = $attributes['port'];
            }

            // ソケットオブジェクト作成
            $this->socket = new SyL_Socket($this->host, $this->port);
            $this->socket->setDebugCallBackFunc(array(&$this, 'receiveMessage'));

            if (!$this->socket->open()) {
                $this->error_message = $this->socket->getLastError();
                return false;
            } else {
                // 接続メッセージ取得
                $this->socket->receive();
                // ログインメッセージ送信
                $this->socket->send('HELO ' . $this->host);
                // ログインメッセージ取得
                $this->socket->receive();
            }
        }
        return true;
    }

    /**
     * メール送信実行
     *
     * @access public
     * @return OK: true, NG: false
     */
    function send()
    {
        if (!parent::send()) {
            return false;
        }

        // ソケット作成判定
        if (!is_object($this->socket) || !$this->socket->isSocket()) {
            $this->error_message = "[SyL error] Socket not created";
            return false;
        }

        // コマンド発行 ------------------------------------------------------------

        // 送信元セットメッセージ送信
        $this->socket->send('MAIL FROM: ' . $this->headers['MAIL_FROM']);
        // 送信元セットメッセージ取得
        $this->socket->receive();

        foreach ($this->headers['RCPT_TO'] as $to) {
            // 送信先セットメッセージ送信
            $this->socket->send('RCPT TO: ' . $to);
            // 送信先セットメッセージ取得
            $this->socket->receive();
        }

        if ($this->isError()) {
            return false;
        }

        // メールヘッダー ----------------------------------------------------------

        // データセットメッセージ送信
        $this->socket->send('DATA');
        // データセットメッセージ取得
        $this->socket->receive();

        // メールヘッダを含む全文取得
        // ※「.」はエスケープ
        $data = $this->getHeaderMessage(preg_replace('/(\r\n|\n|\r)\.(\r\n|\n|\r)/s', '$1..$2', $this->body));
        // 最後に「.」を付加
        $data .= '.';

        if ($this->isError()) {
            return false;
        }

        // -------------------------------------------------------------------------

        // 送信データセットメッセージ送信
        $this->socket->send($data);
        // 送信データセットメッセージ取得
        $this->socket->receive();

        if ($this->isError()) {
            return false;
        }

        // リセットメッセージ送信
        $this->socket->send('RSET');
        // リセットメッセージ取得
        $this->socket->receive();

        if ($this->isError()) {
            return false;
        }

        // 初期化
        $this->init();

        return true;
    }

    /**
     * メールサーバーとの接続を閉じる
     *
     * @access public
     */
    function quit()
    {
        if (is_object($this->socket) && $this->socket->isSocket()) {
            // 完了メッセージ送信
            $this->socket->send('QUIT');
            // 完了メッセージ取得
            $this->socket->receive();
            // ソケットを閉じる
            $this->socket->close();
        }
    }

    /**
     * 受信メッセージ
     *
     * @access private
     * @param string コマンドメッセージ
     */
    function receiveMessage($type, $message)
    {
        if ($type == 'receive') {
            if (preg_match('/^[4|5][0-9]{2}/', $message)) {
                $this->error_message = "[SyL error] SMTP command error ($message)";
                return false;
            } else {
                return true;
            }
        } else {
            return true;
        }
    }
}

?>
